// Bildspeicher aus Xilinx-Primitiven

`include "discount_defs.v"

module ram(
  input             CLK,     // Clock
  input             NRST,    // Reset#
  input  [13:0]     ADDR,    // 14-bit Address Input
  input  [`Bsz-1:0] DATA_IN, // 8-bit Schreibdaten (Data Input)
  input             WE,      // Schreiben (Write Enable)
  output [`Bsz-1:0] DATA_OUT // 8-bit Lesedaten (Data Output)
);

  // Instanziere 8 BlockSelectRAMs
  generate
    genvar j;
    for (j = 0; j < 8; j = j + 1) begin: INST
      RAMB16_S1 RAMB16_S1(
                          .DO(DATA_OUT[j]), // bitweiser Anschluss
                          .DI(DATA_IN[j]),  // bitweiser Anschluss
                          .ADDR(ADDR),
                          .CLK(CLK),
                          .EN(1'b1),  // Enable, immer aktiv
                          .WE(WE),    // Schreiben
                          .SSR(1'b0)  // Register nicht zuruecksetzen
                         );
    end
  endgenerate

  // Globaler Reset (GSR)
 // STARTUP_VIRTEX2 STARTUP_VIRTEX2(.GSR(~NRST));

endmodule
